#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <string.h>
#include "typedefs.h"

#define PORT          PORTB
#define PORT_DIR      DDRB
#define PORT_PIN      PINB
#define PIN_PTT       PB3               //      pin 2
#define PIN_PTT2      PB2               //      pin 7
#define PIN_MODE      PB4               //      pin 3

/*   */
void IOInit(void);
void nop(void);
void startTCNT1(void);
void stopTCNT1(void);
void Wait(UINT16 delay);
void Wait_us(UINT16 delay);
void Wait_ms(UINT16 delay);
void PTT_ON(void);
void PTT_OFF(void);

//#define MORSE_FREQUENCY_STEP (UINT8)((2048UL*FT/(F_CPU/510UL))+0.5)
//     
#define     MORSE_DOT_LENGTH             12
//     FT ( )
//#define MORSE_FREQUENCY_STEP (UINT8)((1024UL*FT/(F_CPU/510UL))+0.5)

//     
#define     MORSE_COEFF_DASH             3.0

// 
#define     SPACE                        0x20

//  
#define     EXCLAMATION_MARK             0x21

//    ,    
#define     MORSE_DASH_LENGTH            MORSE_COEFF_DASH*MORSE_DOT_LENGTH

//   
#define     MORSE_PAUSE_WITHIN_SIGN      MORSE_DOT_LENGTH

//  
#define     MORSE_PAUSE_BETWEEN_SIGNES   MORSE_DASH_LENGTH

//    
#define     MORSE_PAUSE_BETWEEN_WORDS    MORSE_COEFF_DASH*MORSE_DASH_LENGTH

#define nop() __asm__ volatile("nop");
